#ifndef YYERRCODE
#define YYERRCODE 256
#endif

#define L_EOS 257
#define L_IPADDR 258
#define L_NUMBER 259
#define L_STRING 260
#define L_QSTRING 261
#define L_END_INCLUDE 262
#define T_INCLUDE 263
#define T_OPTIONS 264
#define T_DIRECTORY 265
#define T_PIDFILE 266
#define T_NAMED_XFER 267
#define T_DUMP_FILE 268
#define T_STATS_FILE 269
#define T_MEMSTATS_FILE 270
#define T_FAKE_IQUERY 271
#define T_RECURSION 272
#define T_FETCH_GLUE 273
#define T_HITCOUNT 274
#define T_QUERY_SOURCE 275
#define T_LISTEN_ON 276
#define T_PORT 277
#define T_ADDRESS 278
#define T_RRSET_ORDER 279
#define T_ORDER 280
#define T_NAME 281
#define T_CLASS 282
#define T_CONTROLS 283
#define T_INET 284
#define T_UNIX 285
#define T_PERM 286
#define T_OWNER 287
#define T_GROUP 288
#define T_ALLOW 289
#define T_DATASIZE 290
#define T_STACKSIZE 291
#define T_CORESIZE 292
#define T_DEFAULT 293
#define T_UNLIMITED 294
#define T_FILES 295
#define T_VERSION 296
#define T_HOSTSTATS 297
#define T_HOSTSTATSMAX 298
#define T_DEALLOC_ON_EXIT 299
#define T_TRANSFERS_IN 300
#define T_TRANSFERS_OUT 301
#define T_TRANSFERS_PER_NS 302
#define T_TRANSFER_FORMAT 303
#define T_MAX_TRANSFER_TIME_IN 304
#define T_SERIAL_QUERIES 305
#define T_ONE_ANSWER 306
#define T_MANY_ANSWERS 307
#define T_NOTIFY 308
#define T_AUTH_NXDOMAIN 309
#define T_MULTIPLE_CNAMES 310
#define T_USE_IXFR 311
#define T_MAINTAIN_IXFR_BASE 312
#define T_CLEAN_INTERVAL 313
#define T_INTERFACE_INTERVAL 314
#define T_STATS_INTERVAL 315
#define T_MAX_LOG_SIZE_IXFR 316
#define T_HEARTBEAT 317
#define T_USE_ID_POOL 318
#define T_MAX_NCACHE_TTL 319
#define T_HAS_OLD_CLIENTS 320
#define T_RFC2308_TYPE1 321
#define T_LAME_TTL 322
#define T_MIN_ROOTS 323
#define T_TREAT_CR_AS_SPACE 324
#define T_LOGGING 325
#define T_CATEGORY 326
#define T_CHANNEL 327
#define T_SEVERITY 328
#define T_DYNAMIC 329
#define T_FILE 330
#define T_VERSIONS 331
#define T_SIZE 332
#define T_SYSLOG 333
#define T_DEBUG 334
#define T_NULL_OUTPUT 335
#define T_PRINT_TIME 336
#define T_PRINT_CATEGORY 337
#define T_PRINT_SEVERITY 338
#define T_SORTLIST 339
#define T_TOPOLOGY 340
#define T_SERVER 341
#define T_LONG_AXFR 342
#define T_BOGUS 343
#define T_TRANSFERS 344
#define T_KEYS 345
#define T_SUPPORT_IXFR 346
#define T_ZONE 347
#define T_IN 348
#define T_CHAOS 349
#define T_HESIOD 350
#define T_TYPE 351
#define T_MASTER 352
#define T_SLAVE 353
#define T_STUB 354
#define T_RESPONSE 355
#define T_HINT 356
#define T_MASTERS 357
#define T_TRANSFER_SOURCE 358
#define T_PUBKEY 359
#define T_ALSO_NOTIFY 360
#define T_DIALUP 361
#define T_FILE_IXFR 362
#define T_IXFR_TMP 363
#define T_TRUSTED_KEYS 364
#define T_ACL 365
#define T_ALLOW_UPDATE 366
#define T_ALLOW_QUERY 367
#define T_ALLOW_TRANSFER 368
#define T_ALLOW_RECURSION 369
#define T_BLACKHOLE 370
#define T_SEC_KEY 371
#define T_ALGID 372
#define T_SECRET 373
#define T_CHECK_NAMES 374
#define T_WARN 375
#define T_FAIL 376
#define T_IGNORE 377
#define T_FORWARD 378
#define T_FORWARDERS 379
#define T_ONLY 380
#define T_FIRST 381
#define T_IF_NO_ANSWER 382
#define T_IF_NO_DOMAIN 383
#define T_YES 384
#define T_TRUE 385
#define T_NO 386
#define T_FALSE 387
typedef union {
	char *			cp;
	int			s_int;
	long			num;
	u_long			ul_int;
	u_int16_t		us_int;
	struct in_addr		ip_addr;
	ip_match_element	ime;
	ip_match_list		iml;
	rrset_order_list	rol;
	rrset_order_element	roe;
	struct dst_key *	keyi;
	enum axfr_format	axfr_fmt;
} YYSTYPE;
extern YYSTYPE yylval;
